from CSVReader import *

"""
Runs shell commands to upload files
to a remote web server.
Requires SSH keys.
"""

class Uploader(CSVReader):

    def __init__(self,csv_file):
        self.load_csv_into_memory(csv_file)

    def upload(self):
        """
        Upload files, if necessary
        """
        for row in self.all_dat:

            # Iterating over each phone call/audio file record

            old_url = row['file']
            filename = old_url.split('/')[-1]
            my_url = 'http://charlesreid1.com/ThisIsWatergate/'
            new_url = my_url + filename

            from urllib2 import urlopen,HTTPError
            try:
                code = urlopen(new_url).code
                if (code/100.0 >= 4):
                    raise HTTPError
                else:
                    print "File "+filename+" already exists at "+new_url
            except HTTPError:
                # no resource there...
                # lets download, then upload 

                print "Downloading file "+filename
                os.system('wget -P files/ '+old_url)
                
                print "Uploading file "+filename
                localfile = 'files/'+filename
                remotehost = 'charles@charlesreid1.com'
                remotefile = '/www/htdocs/ThisIsWatergate/.'

                os.system('scp "%s" "%s:%s"' % (localfile, remotehost, remotefile) )

                #from fabric.api import env
                #from fabric.operations import run, put
                #env.hosts = [remotehost]
                #put(filename,remotefile)


if __name__=="__main__":
    u = Uploader('WatergateTimeline.csv')
    u.upload() 

